%---------------------------------------
%
/inches { 72 mul } def
/cm { 28.34646 mul } def
%
%---------------------------------------
%
% x y max => max(x,y)
% x y min => min(x,y)
%
/max {			% x y
   ge {x} {y} ifelse	% max(x,y)
} def
%
/min {			% x y
   le {x} {y} ifelse	% min(x,y)
} def
%
%---------------------------------------
%
% x y u v line => ---
%
/line {
    moveto	% x y
    lineto
} def
%
%---------------------------------------
%
% x y u v lin => ---
/lin {
   gsave	% x y u v
   newpath	% x y u v
   line		%
   stroke	%
   grestore	%
} def
%
%---------------------------------------
%
% x y z parametric => ((z-x)/(y-x))
%
/parametric {		% x y z
    2 index		% x y z x
    sub			% x y (z-x)
    3 1 roll		% (z-x) x y
    exch		% (z-x) y x
    sub			% (z-x) (y-x)
    div			% ((z-x)/(y-x))
} def
%
%---------------------------------------
%
% x y r invParametric => (x+(r*(y-x)))
%
/invParametric {	% x y r
    3 1 roll		% r x y
    exch		% r y x
    dup			% r y x x
    4 1 roll		% x r y x
    sub			% x r (y-x)
    mul			% x (r*(y-x))
    add			% (x+(r*(y-x)))
} def
%
%---------------------------------------
%
/aHPos     { 0.65 } def
/aHFill    { 0.20 } def
%
% --- arrowHead => ---
%
% arrowhead
/arrowhead {
    newpath
    -1  0.5 moveto
     0  0   lineto
    -1 -0.5 lineto
    -0.75 0 lineto
    closepath
    fill
} def
%
% x y u v arrow => ---
%
/arrow {		% x y u v
   4 copy		% x y u v x y u v
   lin			% x y u v
   3 index		% x y u v x
   2 index		% x y u v x u
   aHPos invParametric	% x y u v (x+(aHPos*(u-x)))
   3 index		% x y u v (x+(aHPos*(u-x))) y
   2 index		% x y u v (x+(aHPos*(u-x))) y v
   aHPos invParametric	% x y u v (x+(aHPos*(u-x))) (y+(aHPos*(v-y)))
   gsave		% x y u v (x+(aHPos*(u-x))) (y+(aHPos*(v-y)))
   translate		% x y u v
   2 index		% x y u v y
   sub			% x y u (v-y)
   exch			% x y (v-y) u
   3 index		% x y (v-y) u x
   sub			% x y (v-y) (u-x)
   dup                  % x y (v-y) (u-x) (u-x)
   0                    % x y (v-y) (u-x) (u-x) 0
   eq {pop 1} {} ifelse % x y (v-y) ( (u-x) != 0 ) ? (u-x) : 1
   atan			% x y angle
   rotate		% x y
   pop pop		%
   arrowSize arrowSize scale
   arrowhead
   grestore
} def
%
%---------------------------------------
%
% x y w h rectangle => ---
%
/rectangle {		% x y w h
    4 2 roll		% w h x y
    moveto		% w h
    dup 0 exch rlineto	% w h
    exch 0 rlineto	% h
    neg 0 exch rlineto	%
} def
%
%---------------------------------------
%
% x y w h rect => ---
%
/rect {
    gsave		% x y w h
    newpath		% x y w h
    rectangle		%
    closepath		%
    stroke		%
    grestore		%
} def
%
%---------------------------------------
%
% x y w h fill border frect => ---
%
/frect {		% x y w h fill border
    6 2 roll		% fill border x y w h
    newpath		% fill border x y w h
    rectangle		% fill border
    closepath		% fill border
    exch		% border fill
    gsave		% border fill
    aload pop		% border r g b
    setrgbcolor fill	% border
    grestore		% border
    gsave		% border
    aload pop		% r g b
    setrgbcolor stroke	%
    grestore		%
} def
%
%---------------------------------------
%
% x y dx dy u v du dv arc => ---
%
/arc {			% x y dx dy u v du dv
    gsave		% x y dx dy u v du dv
    newpath		% x y dx dy u v du dv
    startClip		% x y dx dy u v du dv
    4 copy		% x y dx dy u v du dv u v du dv
    rectangle 		% x y dx dy u v du dv
    8 4 roll		% u v du dv x y dx dy
    4 copy		% u v du dv x y dx dy x y dx dy
    rectangle 		% u v du dv x y dx dy
    closepath		% u v du dv x y dx dy
    eoclip		% u v du dv x y dx dy
    rectMidPts		% u v du dv (x+(dx/2)) (y+(dy/2))
    6 2 roll		% (x+(dx/2)) (y+(dy/2)) u v du dv
    rectMidPts		% (x+(dx/2)) (y+(dy/2)) (u+(du/2)) (v+(dv/2))
    arrow		%
    grestore		%
} def
%
%---------------------------------------
%
% startClip => ---
/startClip {
    0 0 10000 10000 rectangle
} def
%
%---------------------------------------
%
% x y w h rectMidPts => (x+(w/2)) (y+(h/2))
/rectMidPts {		% x y w h
    exch 4 1 roll	% w x y h
    2 div add		% w x (y+(h/2))
    3 1 roll exch	% (y+(h/2)) x w
    2 div add		% (y+(h/2)) (x+(w/2))
    exch		% (x+(w/2)) (y+(h/2))
} def
%
%---------------------------------------
%
% x y (s) text => ---
%
/text {			% x y (s)
    3 1 roll		% (s) x y
    moveto		% (s)
    show		%
} def
%
%---------------------------------------
%
% x y dx dy nodesRegion       => ---
% x y dx dy closedNodesRegion => ---
% x y dx dy blobsRegion       => ---
% x y dx dy closedBlobsRegion => ---
% x y dx dy labelRegion       => ---
% x y dx dy iconRegion        => ---
%
/blob	 {		% x y dx dy
   openNodesRegionFill
   openNodesRegionBorder
   frect		% ---
} def
/closedBlob {		% x y dx dy
   closedNodesRegionFill
   closedNodesRegionBorder
   frect		% ---
} def

/nodesRegion {
   color 0 eq
   { openNodesRegionFill
     openNodesRegionBorder
     frect
   }
   { newpath
     rectangle
     closepath
     gsave
     fill
     grestore
     gsave
     openNodesRegionBorder aload pop setrgbcolor stroke
     grestore
   }
   ifelse
} def

/closedNodesRegion {	% x y dx dy
   closedNodesRegionFill
   closedNodesRegionBorder
   frect		% ---
} def
/blobsRegion {		% x y dx dy
   openBlobsRegionFill
   openBlobsRegionBorder
   frect		% ---
} def
/closedBlobsRegion {	% x y dx dy
   closedBlobsRegionFill
   closedBlobsRegionBorder
   frect		% ---
} def
/labelRegion {		% x y dx dy
   labelRegionFill
   labelRegionBorder
   frect		% ---
} def
/iconRegion {		% x y dx dy
   iconRegionFill
   iconRegionBorder
   frect		% ---
} def
%
%---------------------------------------
%
/blobRGB [
[0.000 0.000 0.000]
[0.799 0.981 0.894] [0.782 0.940 0.951] [0.969 0.741 0.955] [0.869 0.847 0.963]
[0.967 0.855 0.856] [0.944 0.961 0.765] [0.968 0.989 0.697] [0.994 0.780 0.897]
[0.878 0.992 0.804] [0.806 0.869 0.997] [1.000 0.637 0.997] [0.935 0.830 0.915]
] def

/arcRGB [
[0.000 0.000 0.000]
[0.000 0.600 0.000]
[0.000 0.000 0.800]
[0.800 0.000 0.000]
[0.600 0.600 0.000]
[0.800 0.000 0.800]
[0.000 0.700 0.700]
[0.028 0.170 0.143] [0.186 0.030 0.121] [0.212 0.029 0.065] [0.122 0.051 0.180]
[0.202 0.087 0.038] [0.095 0.197 0.048] [0.142 0.172 0.021] [0.008 0.073 0.211]
[0.059 0.054 0.209] [0.026 0.213 0.061] [0.222 0.020 0.010] [0.091 0.180 0.096]
] def
%
/sbcolor {                      % colorIndex
   color 1 eq                   % colorIndex
   {  blobRGB exch              % colorIndex rgbval
      get                       % [r g b]
      aload                     % [r g b] r g b
      pop                       % r g b
      setrgbcolor
   }
   {  pop  }
   ifelse
} def
%
/sacolor {                      % colorIndex
   color 1 eq                   % colorIndex
   {  arcRGB exch               % colorIndex rgbval
      get                       % [r g b]
      aload                     % [r g b] r g b
      pop                       % r g b
      setrgbcolor
   }
   {  pop  }
   ifelse
} def
%
%---------------------------------------
